//---------------------------------------------------------------------------
#include <windows.h>
#pragma hdrstop
#include <stdio.h>
#include <stdlib.h>

//---------------------------------------------------------------------------

void usage();
void setup_priv();

bool standby = false;
int timer = 0;

#pragma argsused
int main(int argc, char* argv[])
{
	int option = 0;
	while (++argv, --argc){
		const char *arg = argv[0];
		if (arg[0]=='-'){
			switch (arg[1]){
				case 's':
					standby = true;
					break;
				case 't':
					option = arg[1];
					break;
				default:
					usage();
					return 1;
			}
		} else {
			switch (option){
				case 't':
					timer = atoi(arg);
					break;
				default:
					usage();
					return 1;
			}
			option = 0;
		}
	}
	if (!standby){
		usage();
		return 1;
	}
	if (timer>0){
		Sleep(timer);
	}
	if (standby){
		setup_priv();
		if (!SetSystemPowerState(FALSE, FALSE)){	// suspend
			fprintf(stderr, "suspend error : %d\n", GetLastError());
		}
	}
	return 0;
}
//---------------------------------------------------------------------------


void usage()
{
	printf(
"standby [otions]\n"
"ex.\n"
"standby -s -t xxx\n"
"  standby after xxx[msec]\n"
	);
}

void setup_priv()
{
    HANDLE hToken;
    TOKEN_PRIVILEGES tknPrvlgs;

    OpenProcessToken(GetCurrentProcess(),
                     TOKEN_ADJUST_PRIVILEGES, &hToken);
    LookupPrivilegeValue(NULL, SE_SHUTDOWN_NAME,
						 &(tknPrvlgs.Privileges[0].Luid));
	tknPrvlgs.PrivilegeCount = 1;
	tknPrvlgs.Privileges[0].Attributes = SE_PRIVILEGE_ENABLED;
	AdjustTokenPrivileges(hToken, FALSE, &tknPrvlgs, 0, NULL, NULL);
}
